2008-12-30 14:17:56     (Need help in) Implementing older spi driver

Document created by Aaronwu Employee on Aug 9, 2013
Version 1Show Document
  • View in full screen mode

2008-12-30 14:17:56     (Need help in) Implementing older spi driver

Jörg Dinger (GERMANY)

Message: 67216   

 

Hello!

 

In my student research project I need to read  voltage values from a daugthercard and forward them to a host pc. For doing so, I need a spi driver to access the daugthercard and transfer the values. As I have to use µClinux version 2006R2 RC2, the driver should run under this version.

 

Under discussion with Mr Michael Hennerich he gave me the hint to use the older spi driver adsp-spiadc.c/h und adsp-spidma.c instead of the newer spi bus driver bfin_spi_adc.c because I intend to have a permanent data transfer to the host. Regrettably, until now I have not been able to implement the older driver version in my uClinux. According to Mr Hennerichs hints, there must be taken some changes in the following files found in uClinux-dist/linux-2.6.x/drivers/char/: kconfig and makefile. Furthermore, you would need to copy those files in this directory. I would be really greatful to cooperativ users who can help me out because I don't know how to continue and time is running out.

 

 

 

The following attempts have failed:

1) Changes in Kconfig und Makefile as described in [1]:

 

 

.../drivers/char/Kconfig:

config SPIDMA_BF53x

    bool "Blackfin BF53x ADSP SPI DMA (obsolete)"

    depends on BFIN

    default n

    ---help---

 

.../drivers/char/Makefile:

obj-$(CONFIG_BF5xx_PPIADC) += ppiadc.o bf533_timers.o

 

The subsequent make command caused an error. (try_1.txt)

 

2) Changes in Kconfig und Makefile as described in [2]:

 

.../drivers/char/Kconfig:

config BFIN_SPI_CHANNEL

    bool "Blackfin BF53x SPI port support"

    depends on BFIN

    default n

    ---help---

  

config SPI_ADC_BF533  

    bool "Blackfin BF53x ADSP SPI ADC support"

    depends on BFIN

    select BFIN_SPI_CHANNEL

    default n

    ---help---

 

.../drivers/char/Makefile:

obj-$(CONFIG_BFIN_SPI_CHANNEL)  += bfin_spi_channel.o

 

Besides, I added the file bfin_spi_channel.c in the ../dribers/char directory. The subsequent make command caused an error. (try_2.txt)

 

 

To tell the truth, I am fairly at a loss, because I don't get the driver implemented ans I am not that familiar with all dependencies in uClinux.

 

J. Dinger

 

 

 

My used Environment:

 

- ADSP-BF537 EZ Kit Lite Board

 

- AD7476A_SPI_ADC v1.0 AD-Wandler-Tochterkarte / AD-Daugthercard

 

- µClinux (Version 2006R2 RC2)

 

 

 

 

 

 

 

German Version of this article: ----------------------------------------------------------------------------

 

Guten Tag!

 

In meiner Studienarbeit beschäftige ich mich damit, Spannungswerte von einer Tochterkarte einzulesen und diese an den Host weiterzuleiten. Hierzu benötige ich einen SPI-Treiber. Da ich die µClinux Version 2006R2 RC2 verwenden soll, muss der Treiber dort lauffähig sein.

 

Im Gespräch mit Herrn Michael Hennerich wurde ich darauf hingewiesen, dass ich statt des neuen SPI-Bustreibers bfin_spi_adc.c die älteren Treiber adsp-spiadc.c/h und adsp-spidma.c werden muss, da ich eine permanente Datenübertragung beabsichtige. Die Einbindung dieser älteren Treiber ist mir allerdings bisher noch nicht gelungen. Herrn Hennerichs Hinweisen zufolge sind Anpassungen an den Dateien kconfig und makefile im Ordner uClinux-dist/linux-2.6.x/drivers/char/ notwendig. Zusätzlich müssten die älteren Treiberdateien dorthin kopiert werden. Ich wäre hilfsbereiten Usern wirklich sehr dankbar, da ich alleine nicht weiterweiß und die Zeit langsam davonrennt.

 

Folgende Implementierungsversuche schlugen fehl:

1) Änderungen in Kconfig und Makefile wie in [1] beschrieben:

 

 

 

.../drivers/char/Kconfig:

config SPIDMA_BF53x

    bool "Blackfin BF53x ADSP SPI DMA (obsolete)"

    depends on BFIN

    default n

    ---help---

 

.../drivers/char/Makefile:

obj-$(CONFIG_BF5xx_PPIADC) += ppiadc.o bf533_timers.o

Der anschließende Make-Befehl erzeugte eine Fehlermeldung. (try_1.txt)

 

2) Änderungen in Kconfig und Makefile der uClinux-dist wie in den entsprechenden Dateteien in [2] beschrieben:

 

.../drivers/char/Kconfig:

config BFIN_SPI_CHANNEL

    bool "Blackfin BF53x SPI port support"

    depends on BFIN

    default n

    ---help---

  

config SPI_ADC_BF533  

    bool "Blackfin BF53x ADSP SPI ADC support"

    depends on BFIN

    select BFIN_SPI_CHANNEL

    default n

    ---help---

 

.../drivers/char/Makefile:

obj-$(CONFIG_BFIN_SPI_CHANNEL)  += bfin_spi_channel.o

 

Dazu habe ich noch die Datei bfin_spi_channel.c in das ../dribers/char Verzeichnis eingefügt. Der anschließende Make-Befehl erzeugte eine Fehlermeldung. (try_2.txt)

 

 

Ich bin ehrlich gesagt ziemlich ratlos, da ich den Treiber nicht eingebunden bekomme und mir nicht alle Abhängigkeiten zwischen den einzelnen Quelldateien ersichtlich sind.

 

J. Dinger

 

Meine verwendete Umgebung:

 

- ADSP-BF537 EZ Kit Lite Board

 

- AD7476A_SPI_ADC v1.0 AD-Wandler-Tochterkarte / AD-Daugthercard

 

- µClinux (Version 2006R2 RC2)

 

 

 

 

 

 

 

try_2.txt

try_1.txt

TranslateQuoteReplyEditDelete

 

 

2008-12-30 15:12:15     Re: (Need help in) Implementing older spi driver

Robin Getz (UNITED STATES)

Message: 67217   

 

Jorg:

 

Upgrade - 2006 is not supported anymore. We support trunk, and the last released version - that would be 2008.

 

-Robin

QuoteReplyEditDelete

 

 

2008-12-30 17:36:05     Re: (Need help in) Implementing older spi driver

Jörg Dinger (GERMANY)

Message: 67221   

 

Thanks for your response!

 

My university's claims using µClinux version 2006R2 RC2, so I have no choice. There must be a way to implement the driver as Michael Hennerich, the programmer of this driver, also said. I only can't figure out how this can be done...

 

I already wrote him an eMail but he not responding since several weeks and I don't want to annoy him. He told me to put my issue in this forum. There must be a way to use this Daugthercard in µClinux version 2006R2 RC2, otherwise it would be useless.

 

J. Dinger

TranslateQuoteReplyEditDelete

 

 

2008-12-30 22:46:52     Re: (Need help in) Implementing older spi driver

Robin Getz (UNITED STATES)

Message: 67223   

 

Jorg:

 

Michael told you how to do it, and that you were on your own. You can't figure it out - I'm sorry, but that is not Micheal's problem. As I stated - we do not support obsolete software packages. Tell your professor to upgrade, and we can help you out if you run into . There isn't much more to say on the subject.

 

As for Micheal's not responding - he is on vacation, but what you are getting is exactly what the support section from the front page of this web site says you will get.

 

http://docs.blackfin.uclinux.org/doku.php?id=copyright_information#maintenance_and_support

 

----------

 

Please do not send private email questions or bug reports to project developers email addresses or mailing lists managed on this site. We do not have the resources/time to reply to them. Normally - they will be deleted without action.

 

----------

 

Deleted without action, means you don't get a reply...

 

 

 

 

QuoteReplyEditDelete

 

 

2009-01-19 05:35:27     Re: (Need help in) Implementing older spi driver

Jörg Dinger (GERMANY)

Message: 68099   

 

What would you have written to anyone who had the same problem 2 years ago?

 

My spi device (daugther brad AD7476A) does not provide correct values. In DC mode, values are a tenth of their real values (e.g. 156 instead of 1560) and AC mode values are not useful at all.

 

So it seems as if the spi driver is not usable for this daugther board...

TranslateQuoteReplyEditDelete

 

 

2009-01-19 09:50:37     Re: (Need help in) Implementing older spi driver

Mike Frysinger (UNITED STATES)

Message: 68105   

 

we would have debugged the driver/framework to see where the problem was coming from

Attachments

    Outcomes